#ifndef __LFAPP_H__
#define __LFAPP_H__
#include <lf/LFwindow.h>
#include <windows.h>

class  LFapp;
extern LFapp *theApp;

LRESULT CALLBACK WindowProc (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ControlWindowProc(HWND, UINT, WPARAM, LPARAM);


class LFapp : public LFobject
{
 public:
                        LFapp();
   virtual              ~LFapp(); 
   virtual int          Run(HINSTANCE,HINSTANCE,LPSTR,int);
   virtual int          GetFrameCount(){return m_frameCount;}
   virtual void         AddFrame(){++m_frameCount;}
   virtual void         RemoveFrame(){--m_frameCount;}
   virtual const char * GetClasName();
   virtual HINSTANCE    GetHist();
   virtual LRESULT      WinProcLF(HWND hwnd, UINT mess, WPARAM wPar, LPARAM lPar);
   virtual LRESULT      ControlWinProcLF(HWND hwnd, UINT mess, WPARAM wPar, LPARAM lPar);
 protected:
   virtual void         OnCreate(WNDCLASSEX &wndClass,LPSTR CmdParam);
   virtual bool         OnInit();
   virtual void         OnExit(int &returnExitValue);
   virtual int          Exit();
           HINSTANCE    m_hThisInstance;
           HINSTANCE    m_hPrevInstance;
           LPSTR        m_lpszCmdParam;
           LFwindow    *LFwinCall;
           int          m_nCmdShow;
           MSG          m_msg;
           int          m_exit;
           int          m_frameCount;
};

#endif
