#ifndef __LFARRAY_H__
#define __LFARRAY_H__

#include <lf/LFobject.h>

class LFarrayBase : public LFobject
{
public:
            LFarrayBase(long nItem);
    virtual ~LFarrayBase();
    
            long           Add(LFobject *item,long pos=-1);
            void           Compact();
            long           GetLast();
            long           GetCount();
    virtual LFobject *     GetItemObject(long item);
protected:
            LFobject     **m_item;
            long           m_count;
            long           m_last;
};

class LFarray : public LFarrayBase
{
public:
            LFarray(long nItem);
            LFobject *     operator [] (long  item);
};

#endif

