#ifndef __LFLISTBASE_H__
#define __LFLISTBASE_H__

#include <lf/LFcontrol.h>
#include <lf/LFstring.h>

class LFlistbase : public LFcontrol
{
 public:
                       LFlistbase(LFwindow *parent,long id,const char * control,
                                  int x=CW_USEDEFAULT,int y=CW_USEDEFAULT,
                                  int width=CW_USEDEFAULT,int height=CW_USEDEFAULT,
                                  unsigned long style=0,unsigned long ExStyle=0);
   virtual             ~LFlistbase();
   virtual  LRESULT    Append(const LFstring item,LFobject *data=NULL);
   virtual  LRESULT    Insert(const LFstring item,LFobject *data=NULL);
   virtual  LRESULT    Append(const char *item,LFobject *data=NULL);
   virtual  LRESULT    Insert(const char *item,LFobject *data=NULL);
   virtual  LRESULT    DeleteItem(UINT item);
   virtual  LRESULT    GetCount();
   virtual  void       Clear();
   virtual  LFobject * GetData(UINT item);
   virtual  LRESULT    SetData(UINT item,LFobject *data);
   virtual  LRESULT    Select(UINT item);
   virtual  LRESULT    GetSelect();
   virtual  LRESULT    SelectItem(UINT item); //  only listbox
   virtual  LRESULT    GetSelectItem(UINT item);// only listbox
   
 protected:
            UINT       m_parAppend;
            UINT       m_parInsert;
            UINT       m_parDelete;
            UINT       m_parGetData;
            UINT       m_parSetData;
            UINT       m_parDeleteAll;
            UINT       m_parCount;
            UINT       m_parGetSelItem;
            UINT       m_parSelItem;
            long       m_tipoLista;
            
};
 
#endif


