#include <lf/LFapp.h>
#include <lf/LFwindow.h>

char className[255]="LFapplication";

LFapp *theApp;

LFapp::LFapp()
{
    theApp=this;
    m_frameCount=0;
}

LFapp::~LFapp()
{

}

int LFapp::Run(    
                HINSTANCE hInst,
                HINSTANCE hPrevInst,
                LPSTR     lParam,
                int       Show
)
{
    m_hThisInstance=hInst;
    m_hPrevInstance=hPrevInst;
    m_lpszCmdParam=lParam;
    m_nCmdShow =Show;

    m_exit=0;

    WNDCLASSEX m_wndClass;
    m_wndClass.hInstance = hInst;
    m_wndClass.lpszClassName = className;
    m_wndClass.style = 0;
    m_wndClass.cbSize=sizeof(WNDCLASSEX); 
    m_wndClass.lpfnWndProc = WindowProc;
    m_wndClass.hIcon= LoadIcon (LFNULL, IDI_APPLICATION);
    m_wndClass.hIconSm= LoadIcon (LFNULL, IDI_APPLICATION);
    m_wndClass.hCursor=LoadCursor (LFNULL, IDC_ARROW);
    m_wndClass.hbrBackground=(HBRUSH)COLOR_HIGHLIGHT;
//    m_wndClass.hbrBackground=(HBRUSH) COLOR_3DSHADOW;
    m_wndClass.lpszMenuName=LFNULL;
    m_wndClass.cbClsExtra = 0;  
    m_wndClass.cbWndExtra = 0;
    OnCreate(m_wndClass,m_lpszCmdParam);
    if (!::RegisterClassEx(&m_wndClass))m_exit=1;
    
    if ((m_exit==0) && OnInit()){
        while (::GetMessage (&m_msg, LFNULL, 0, 0))
        {
            ::TranslateMessage(&m_msg);
            ::DispatchMessage(&m_msg);
        }  
    }
    return Exit(); 
}



const char * LFapp::GetClasName()
{
 return className;
}


HINSTANCE LFapp::GetHist()
{
 return m_hThisInstance;
}


void LFapp::OnCreate(WNDCLASSEX &wndClass,LPSTR CmdParam)
{
 
}

bool LFapp::OnInit()
{
   
    return true;
}



void LFapp::OnExit(int &returnExitValue)
{

}



LRESULT  LFapp::WinProcLF(HWND hwnd, UINT mess, WPARAM wPar, LPARAM lPar)
{
    HWND hwndTmp=hwnd;
    switch (mess)
    {
        case WM_COMMAND:hwndTmp=(HWND)lPar;break;
    }    
    LFwinCall=(LFwindow *)((LFobject *)GetWindowLong(hwndTmp,GWL_USERDATA));
    if(LFwinCall==LFNULL)return ::DefWindowProc (hwnd, mess, wPar, lPar);
    LFwindowPanel *tmpWinProc=(LFwindowPanel*)LFwinCall->GetWindowProcEvent();
    if(tmpWinProc==LFNULL){tmpWinProc=(LFwindowPanel*)LFwinCall;}
    tmpWinProc->SetLFwinCall(LFwinCall);
    LFevent event;
    event.hwnd=hwnd;event.mess=mess;
    event.wPar=wPar;event.lPar=lPar;
    return tmpWinProc->WinProc(event);
}

LRESULT LFapp::ControlWinProcLF(HWND hwnd, UINT mess, WPARAM wPar, LPARAM lPar)
{
    HWND hwndTmp=hwnd;bool tmpCmdEv=false;
    switch (mess)
    {
        case WM_COMMAND:{
            hwndTmp=(HWND)lPar;tmpCmdEv=true;
            break;
        }
    }    
    LFwinCall=(LFwindow *)((LFobject *)GetWindowLong(hwndTmp,GWL_USERDATA));
    LFwindowPanel *tmpWinProc=(LFwindowPanel*)LFwinCall->GetWindowProcEvent();
    if(tmpWinProc==LFNULL){
        tmpWinProc=(LFwindowPanel*)LFwinCall;
    }
    tmpWinProc->SetLFwinCall(LFwinCall);
    LFevent event;
    event.hwnd=hwnd;event.mess=mess;
    event.wPar=wPar;event.lPar=lPar;
    if(tmpCmdEv){return tmpWinProc->WinProc(event);}
    return tmpWinProc->ControlWinProc(event);
}


int LFapp::Exit()
{
    OnExit(m_exit);
    return m_exit;
}
