#include <lf/LFapp.h>
#include <lf/LFpanel.h>
using namespace std;
LFpanel::LFpanel(LFwindow *parent,long id,int x,int y,
                int width,int height,unsigned long style,unsigned long ExStyle)
{ 
    HWND tmphwnd;SetWindowProcEvent(true);
    if (id == -1){
      id=NewWinId();
    } 
    if(parent!=LFNULL)tmphwnd=parent->GetHwnd();else tmphwnd=LFNULL;
    m_parent=parent;LFwinCall=LFNULL;
    SetLFwinCall(LFNULL);
    m_hwnd=CreateWindowEx(ExStyle,"STATIC","",style,x,y,width,height,    
                        tmphwnd,(HMENU)id,theApp->GetHist(),LFNULL);
    
    ::SetWindowLong(m_hwnd,GWL_USERDATA,(long)((LFobject*)this));
    m_lpPrevWndProc=(WNDPROC)WindowProc;
    CaptureEvent();
    GetRect();

} 

LFpanel::~LFpanel()
{
    RemoveCaptureEvent(); 
}

void LFpanel::Destroy()
{
// no frame

//    theApp->RemoveFrame();
//    if(!theApp->GetFrameCount())PostQuitMessage (0);
}


LRESULT LFpanel::WinProc(LFevent &event)
{
    switch (event.mess)
    {
        case WM_DESTROY:
            break;
        default: 
            return ::DefWindowProc (event.hwnd, event.mess, event.wPar, event.lPar);
            break;
    } 
    return 0;
}

LRESULT LFpanel::ControlWinProc(LFevent &event)
{
    LFwindow   *win=LFwinCall;// don't modify
    switch (event.mess)
    {
        
    }
    // don't use LFwinCall;
    return ::CallWindowProc(win->GetPrevWndProc(),event.hwnd,event.mess,event.wPar,event.lPar);
}

