#ifndef __LFSTRING_H__
#define __LFSTRING_H__

#include <lf/LFobject.h>
 
#define LFSTRLENGTHMIN 255L

  
class LFstring : public LFobject
{  
 public:
                         LFstring();
                         LFstring(const char * value,long length=LFSTRLENGTHMIN,bool check=true);
                         LFstring(const LFstring &LFstr);
                  char * nc_str();
            const char * c_str() const;
                  char * Alloc(long size);
            void         Copy(const char *source);
            void         Copy(const LFstring &LFstr);
            void         Append(const char *source);
            void         Append(const LFstring &LFstr); 
   const    LFstring&    operator  = (const char * value);
   const    LFstring&    operator  = (const LFstring& value);
            LFstring     operator  + (const LFstring& value);
            LFstring     operator  + (const char * value);
   friend   LFstring     operator  + (const char * value,const LFstring& value);
            LFstring&    operator << (const long value);
            LFstring&    operator << (const char * value);
            LFstring&    operator << (const LFstring& value);
            bool         operator == (const LFstring& value);
            bool         operator == (const char * value);
            bool         operator != (const LFstring& value);
            bool         operator != (const char * value);
            char&        operator [] (long  value);
   virtual               ~LFstring();
 protected:
            void         initLFstring(const char * value,long length=LFSTRLENGTHMIN,bool check=true);
            void         MemAlloc(long size=LFSTRLENGTHMIN);
            void         MemReAlloc(long size=LFSTRLENGTHMIN,bool copy=true);
            char        *m_buffer;
            long         m_length;
            bool         m_check;
};


#endif


