#include <lf/LFapp.h>
#include <lf/LFcombobox.h> 


LFcombobox::LFcombobox(LFwindow *parent,long id,int x,int y,int width,
                     int height,unsigned long style,unsigned long ExStyle):
           LFlistbase(parent,id,"COMBOBOX",x,y,width,height,style,ExStyle)
{ 
    if(height < (m_rect.bottom + m_rect.bottom)){
        m_heightComboList=m_rect.bottom + 200;
    }else{
        m_heightComboList=height - m_rect.bottom;
    }
    SetRect(m_rect);
    m_type = LF_LFCOMBOBOX;
}


LFcombobox::~LFcombobox() 
{ 

}   

void LFcombobox::SetHeightComboList(int heightComboList)
{
    m_heightComboList=heightComboList;
    SetRect(m_rect.left,m_rect.top,m_rect.right,m_rect.bottom);
}

void LFcombobox::SetRect(int x,int y,int cx,int cy,bool refresh)
{
    LFwindow::SetRect(x,y,cx,m_rect.bottom + m_heightComboList,refresh);
    GetRect();
}   
int LFcombobox::GetHeightComboList()
{
    return m_heightComboList;
}


void LFcombobox::SetRect(RECT &rect,bool refresh)
{
    SetRect(rect.left,rect.top,rect.right,rect.bottom,refresh);
}   





