#include <lf/LFapp.h>
#include <lf/LFcontrol.h> 


LFcontrol::LFcontrol(LFwindow *parent,long id,const char * control,int x,int y,int width,
                     int height,unsigned long style,unsigned long ExStyle)
{ 
    if (id == -1){
      id=NewWinId();
    } 
    HWND tmphwnd;SetWindowProcEvent(false);
    if(parent!=LFNULL)tmphwnd=parent->GetHwnd();else tmphwnd=LFNULL;
    m_idWin=id;m_parent=parent;
    m_hwnd=::CreateWindowEx(ExStyle,control,"",style| WS_CHILD,x,y,width,height,    
                            tmphwnd,(HMENU)id,theApp->GetHist(),LFNULL);
    ::SetWindowLong(m_hwnd,GWL_USERDATA,(long)((LFobject*)this));
    m_type = LF_LFCONTROL;
    GetRect();
}

LFcontrol::~LFcontrol() 
{

}   
 
void LFcontrol::SetCheck(bool check=true)
{
    SendMessage(m_hwnd,BM_SETCHECK,check,0);
}   
 
void LFcontrol::SetState(bool state=true)
{
    SendMessage(m_hwnd,BM_SETSTATE,state,0);
}   
 
long LFcontrol::GetCheck()
{
    return SendMessage(m_hwnd,BM_GETCHECK,0,0);
}   
 
long LFcontrol::GetState()
{
    return SendMessage(m_hwnd,BM_GETSTATE,0,0);
}   
 
