#include <lf/LFapp.h>
#include <lf/LFframe.h>
using namespace std;
LFframe::LFframe(LFwindow *parent,const char *title,int x,int y,
                int width,int height,unsigned long style,unsigned long ExStyle)
{ 
    HWND tmphwnd;SetWindowProcEvent(true);
    if(parent!=LFNULL)tmphwnd=parent->GetHwnd();else tmphwnd=LFNULL;
    m_parent=parent;LFwinCall=LFNULL;
    SetLFwinCall(LFNULL);
    m_hwnd=CreateWindowEx(ExStyle,theApp->GetClasName(),title,style,x,y,width,height,    
                        tmphwnd,(HMENU)LFNULL,theApp->GetHist(),LFNULL);
    
    ::SetWindowLong(m_hwnd,GWL_USERDATA,(long)((LFobject*)this));
    m_type = LF_LFFRAME;
    m_lpPrevWndProc=(WNDPROC)WindowProc;
    theApp->AddFrame();
    GetRect();

} 

LFframe::~LFframe()
{
 
}

void LFframe::Destroy()
{
    theApp->RemoveFrame();
    if(!theApp->GetFrameCount())PostQuitMessage (0);
}

void LFframe::Close()
{
 PostMessage (m_hwnd, WM_CLOSE, 0, 0L);
}

LRESULT LFframe::WinProc(LFevent &event)
{
    switch (event.mess)
    {
        case WM_DESTROY:
            Destroy();
            break;
        default: 
            return ::DefWindowProc (event.hwnd, event.mess, event.wPar, event.lPar);
            break;
    } 
    return 0;
}

LRESULT LFframe::ControlWinProc(LFevent &event)
{
    LFwindow   *win=LFwinCall;// don't modify
    switch (event.mess)
    {
        
    }
    // don't use LFwinCall;
    return ::CallWindowProc(win->GetPrevWndProc(),event.hwnd,event.mess,event.wPar,event.lPar);
}



